#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_FishRankCFG.h"
std::auto_ptr<Fish_FishRankCFG> Fish_FishRankCFG::msSingleton(nullptr);

int Fish_FishRankCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FishRankCFGData* Fish_FishRankCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_FishRankCFGData>& Fish_FishRankCFG::GetMapData()
{
	return mMapData;
}

void Fish_FishRankCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_FishRankCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FishRankCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRankName = element->Attribute("RankName");
		data.mIntegral = element->Attribute("Integral");
		data.mStars1 = element->Attribute("Stars1");
		data.mStars2 = element->Attribute("Stars2");
		data.mStars3 = element->Attribute("Stars3");
		{
			const char* RankRewardId = element->Attribute("RankRewardId");
			std::vector<std::string> vecRankRewardId;
			boost::split(vecRankRewardId, RankRewardId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRankRewardId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRankRewardId[i].c_str(), &temp))
				{
					data.mRankRewardId.push_back(temp);
				}
			}
		}
		{
			const char* RankRewardCount = element->Attribute("RankRewardCount");
			std::vector<std::string> vecRankRewardCount;
			boost::split(vecRankRewardCount, RankRewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRankRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRankRewardCount[i].c_str(), &temp))
				{
					data.mRankRewardCount.push_back(temp);
				}
			}
		}
		{
			const char* SeaGodRewardId = element->Attribute("SeaGodRewardId");
			std::vector<std::string> vecSeaGodRewardId;
			boost::split(vecSeaGodRewardId, SeaGodRewardId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecSeaGodRewardId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecSeaGodRewardId[i].c_str(), &temp))
				{
					data.mSeaGodRewardId.push_back(temp);
				}
			}
		}
		{
			const char* SeaGodRewardCount = element->Attribute("SeaGodRewardCount");
			std::vector<std::string> vecSeaGodRewardCount;
			boost::split(vecSeaGodRewardCount, SeaGodRewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecSeaGodRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecSeaGodRewardCount[i].c_str(), &temp))
				{
					data.mSeaGodRewardCount.push_back(temp);
				}
			}
		}
		data.mGiftId = element->IntAttribute("GiftId");
		data.mResources = element->Attribute("Resources");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_FishRankCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_FishRankCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_FishRankCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_FishRankCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_FishRankCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "RankName", data.mRankName);
		LuaCfgHelper::readString(L, "Integral", data.mIntegral);
		LuaCfgHelper::readString(L, "Stars1", data.mStars1);
		LuaCfgHelper::readString(L, "Stars2", data.mStars2);
		LuaCfgHelper::readString(L, "Stars3", data.mStars3);
		LuaCfgHelper::readVectorInt(L, "RankRewardId", data.mRankRewardId);
		LuaCfgHelper::readVectorInt(L, "RankRewardCount", data.mRankRewardCount);
		LuaCfgHelper::readVectorInt(L, "SeaGodRewardId", data.mSeaGodRewardId);
		LuaCfgHelper::readVectorInt(L, "SeaGodRewardCount", data.mSeaGodRewardCount);
		LuaCfgHelper::readInt(L, "GiftId", data.mGiftId);
		LuaCfgHelper::readString(L, "Resources", data.mResources);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_FishRankCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_FishRankCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_FishRankCFG* Fish_FishRankCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FishRankCFG());
	}
	return msSingleton.get();
}

void Fish_FishRankCFG::Release()
{
	msSingleton.reset(nullptr);
}
